package cz.muni.fi.pa165.general;

import java.util.*;

public class Employee extends Person {
    
    private double salary;
    
    public Employee(String n, double s) {
        super(n);
        salary = s;
    }

    public void setSalary(double s) {
        salary = s;
    }
    
    public double getSalary() {
        return salary;
    }
    
    public static void main(String[] args) {

        Employee e1 = new Employee("Pavel Horak", 12000);
        Employee e2 = new Employee("Josef Novotny", 13000);
        Employee e3 = new Employee("Libor Novotny", 15000);

        SortedSet employees = new TreeSet(new EmployeeSalaryComparator());

        employees.add(e1);
        employees.add(e2);
        employees.add(e3);
        
        for(Iterator i = employees.iterator(); i.hasNext(); ) {
            Employee e = (Employee) i.next();
            System.out.println(e.getName()+", salary="+e.getSalary());
        }            
        
        System.out.println();

        employees = new TreeSet(new PersonNameComparator());

        employees.add(e1);
        employees.add(e2);
        employees.add(e3);
        
        for(Iterator i = employees.iterator(); i.hasNext(); ) {
            Employee e = (Employee) i.next();
            System.out.println(e.getName()+", salary="+e.getSalary());
        }            

        System.out.println();
        
        // konstantni komparator zde vyhovi take 
        employees = new TreeSet(PersonNameComparator.PNC);

        employees.add(e1);
        employees.add(e2);
        employees.add(e3);
        
        for(Iterator i = employees.iterator(); i.hasNext(); ) {
            Employee e = (Employee) i.next();
            System.out.println(e.getName()+", salary="+e.getSalary());
        }            
    }

}