package cz.muni.fi.pa165.jdbc;

import java.sql.*;

public class PeopleDatabase {

  static Person[] people =
  {
  	new Person("Pavel", "Novak", 30),
  	new Person("Jiri", "Berkovec", 35),
  	new Person("Josef", "Makovsky", 50)
  };

  public static void main(String[] args)
  {

    Connection con = null;
    int iRowCount = 0;
    Statement stmt = null;

    String sDriver = "org.hsqldb.jdbcDriver";
    // String sURL = "jdbc:hsqldb:."; 				// uses in-memory db
    String sURL = "jdbc:hsqldb:hsql://localhost"; 	// uses standalone server
    String sUsername = "sa";
    String sPassword = "";

    try { 
        Class.forName( sDriver ).newInstance();
        
    } catch( Exception e ) {
    	
      System.err.println( "Failed to load driver "+sDriver);
      return;
    }

    try {

      con = DriverManager.getConnection ( sURL,
                                          sUsername,
                                          sPassword);
      stmt = con.createStatement();
    }
    catch ( Exception e)
    {
      System.err.println( "problems connecting to " + sURL + ":" );
      System.err.println( e.getMessage() );

      if( con != null)
      {
        try { con.close(); }
        catch( Exception e2 ) {
        	    	e2.printStackTrace();
        }
      }

      return;
    } // end catch

    try
    {
      stmt.executeUpdate( "DROP TABLE PEOPLE" );
      System.out.println( "Table PEOPLE was removed.");
    }
    catch ( Exception e ) { 
    	e.printStackTrace();
    }


    // execute SQL commands
    // to create table and insert data
    try
    {
      stmt.executeUpdate( "CREATE TABLE PEOPLE (" +
             "FIRSTNAME  VARCHAR (15) NOT NULL, "   +
             "SURNAME    VARCHAR (20) NOT NULL, "   +
             "AGE        INTEGER      NOT NULL "   +
                                          ")" );

      System.out.println("Table PEOPLE created, now inserting...");

      for (int i = 0; i < people.length; i++)
      {
        iRowCount +=
        stmt.executeUpdate(
          "INSERT INTO PEOPLE VALUES ("
           + "'" + people[i].getFirstname()+ "'," 
           + "'" + people[i].getSurname()+ "'," 
           + people[i].getAge() + ")"
        );
      }

      System.out.println( iRowCount +
         " Rows inserted into PEOPLE.");

    }
    catch ( Exception e ) {
      System.err.println( e.getMessage() );
    }
    finally {
      try { 
      		stmt.close(); 
      } catch( Exception e ) {
      		e.printStackTrace();
      }
      try { 
      		con.close(); 
      } catch( Exception e ) {
      		e.printStackTrace();
      }
    } // end finally clause

  } // end main

} // end class 
