<?xml version="1.0" encoding="Windows-1250"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        version="1.0">

    <xsl:param name="el.outputs" select="''"/>
    
    <xsl:output method="text"/>

    <xsl:template match="/">
ECHO Generating outputs: <xsl:value-of select="$el.outputs"/> 
<xsl:apply-templates select="*"/>
    </xsl:template>

    <xsl:template match="output">
        <xsl:if test="contains(concat($el.outputs, ';'), concat(@id, ';'))">
            <xsl:text>
ECHO output </xsl:text>
            <xsl:value-of select="@id"/> from <xsl:value-of select="@src"/> type <xsl:value-of select="@type"/>    
            <xsl:text>...
</xsl:text>
            <xsl:apply-templates select="*" mode="teechains"/>
            <xsl:text>CHAIN </xsl:text>
            <xsl:apply-templates select="*" mode="mainchain"/>
            <xsl:text>
#END output </xsl:text>
            <xsl:value-of select="@id"/>
        </xsl:if>
    </xsl:template>

    <xsl:template match="profiles" mode="teechains">
        <xsl:for-each select="security">
            <xsl:variable name="security" select="text()"/>
            <xsl:for-each select="../os">
                <xsl:variable name="os" select="text()"/>
            <xsl:text>
DO $OneProfileTeeChain type=</xsl:text>
            <xsl:value-of select="../../@type"/> target=<xsl:value-of select="../../@type"/>/<xsl:value-of select="../../@type"/>-null.xml profile.security=<xsl:value-of select="$security"/> profile.os=<xsl:value-of select="$os"/> base.dir=<xsl:value-of select="concat(../../@type,'/',$security,'/',$os,'/', ../../@id)"/>
            <xsl:text>/</xsl:text>
            </xsl:for-each>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="profiles" mode="mainchain">
        <xsl:for-each select="security">
            <xsl:variable name="security" select="text()"/>
            <xsl:for-each select="../os">
                <xsl:variable name="os" select="text()"/>
                <xsl:text> $chain-</xsl:text>
                <xsl:value-of select="../../@type"/>-<xsl:value-of select="$security"/>-<xsl:value-of select="$os"/>
            </xsl:for-each>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="profile" mode="teechains">
DO $OneProfileTeeChain type=<xsl:value-of select="../@type"/> target=<xsl:value-of select="../@type"/>/<xsl:value-of select="../@type"/>-null.xml profile.security=<xsl:value-of select="@security"/> profile.os=<xsl:value-of select="@os"/> base.dir=<xsl:value-of select="concat(../@type,'/',@security,'/',@os,'/', ../@id)"/>    
            <xsl:text>/</xsl:text>
    </xsl:template>

    <xsl:template match="profile" mode="mainchain">
        <xsl:text> $chain-</xsl:text>
        <xsl:value-of select="../@type"/>-<xsl:value-of select="@security"/>-<xsl:value-of select="@os"/>
    </xsl:template>

</xsl:stylesheet>