/**
 * FibonacciCounter is an implementation of a simple Fibonacci counter. Note
 * that this code is only instructional.
 */
public class FibonacciCounter {
    /**
     * The counter.
     */
    private int fibonacciCounter;

    /**
     * Default constructor.
     */
    public FibonacciCounter() {
    }

    /**
     * Gets the value of the counter.
     * 
     * @return the counter.
     */
    public int getCounter() {
        return fibonacciCounter;
    }

    /**
     * Sets the value of the counter.
     * 
     * @param counter
     *            the counter.
     */
    public void setCounter(int counter) {
        fibonacciCounter = counter;
    }

    /**
     * Counts the Fibonacci number specified by the preset counter.
     * 
     * @return a Fibonacci number.
     */
    public int count() {
        int fibonacci;
        int counter = getCounter();
        if (counter > 0) {
            fibonacci = 1;
            if (counter > 2) {
                int temporary;
                int previous = fibonacci;
                for (int i = 3; i <= getCounter(); i++) {
                    temporary = previous;
                    previous = fibonacci;
                    fibonacci += temporary;
                }
            }
        } else {
            fibonacci = 0;
        }
        return fibonacci;
    }
}