package tomp.ucebnice.komentare;
/** Tento program spot a vype poet dn
  * od zadanho data v nepestupnm roce.
  */
public class Komentare2 {
    /**
     *  Pole obsahuje poty dn v mscch 1..12
     */
    private static final byte[] dnu = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    /**
     *  Koment k chrnn metod vracejc poet dn v msci
     *  v <i>nepestupnm</i> roce.
     *
     *  @param mesic msc, pro kter se bude vracet poet dn
     *  (leden = 1, nor = 2, ...)
     *
     *  @return poet dn v zadanm msci
     */
    protected static byte pocetDniVMesici(byte mesic) {
    if (mesic < 1 || mesic > 12)
        throw new IllegalArgumentException(
            "Cislo mesice bylo mimo rozsah 1..12.");
    return dnu[mesic-1];
    }

    public static short pocetDniOdZacatkuRoku(byte den, byte mesic) {
    short dnuOdZacatku = 0;
    for (byte i = 1; i < mesic; i++ ) {
        dnuOdZacatku += pocetDniVMesici(i);
    }
    if (den < 1 || den > pocetDniVMesici(mesic))
        throw new IllegalArgumentException(
            "Den "+den+". v mesici "+mesic+". neni");
    dnuOdZacatku += den-1;
    return dnuOdZacatku;
    }
    /**
     * Hlavn vstupn bod do programu
     * @param args[0] slo dne (1..31) a
     * @param args[1] slo msce (1..12), pro nj se bude potat
     * poet dn od zatku nepestupnho roku.
     */
    public static void main(String args[]) {
    byte den = Byte.parseByte(args[0]);
    byte mesic = Byte.parseByte(args[1]);
        System.out.println(pocetDniOdZacatkuRoku(den, mesic));
    }
}