package tomp.ucebnice.narodni;
import tomp.ucebnice.PolozkaComparable;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Locale;
import java.text.Collator;
class PolozkaNarodni extends PolozkaComparable {
    private Collator c;
    public PolozkaNarodni(String nazev, Locale l) {
        super(nazev, 1);
        c = Collator.getInstance(l);
    }
    public int compareTo(Object o) {
        if (o instanceof PolozkaNarodni)
            return c.compare(nazev, ((PolozkaNarodni)o).nazev);
        throw new ClassCastException();
    }
}
public class Razeni {
    private PrintWriter pw;
    public Razeni(PrintWriter pw) {
        this.pw = pw;
    }
    public void usporadej(Locale l) {
        PolozkaNarodni[] polozky = {
            new PolozkaNarodni("cifra", l),
            new PolozkaNarodni("enich", l),
            new PolozkaNarodni("chalupa", l),
            new PolozkaNarodni("bba", l),
            new PolozkaNarodni("baba", l),
            new PolozkaNarodni("babika", l),
        };
        Arrays.sort(polozky);
        pw.println("Jazyk = "+l.getDisplayLanguage());
        pw.println("Zem = "+l.getDisplayCountry());
        for (int i = 0; i < polozky.length; i++)
            pw.println(polozky[i].info());
        pw.println("-----");
    }
    public static void main(String args[])
    throws IOException {
        Razeni r = new Razeni(new PrintWriter(
            new OutputStreamWriter(System.out, "Cp852"), true));
        r.usporadej(new Locale("cs", "CZ"));
        r.usporadej(new Locale("sk", "SK"));
        r.usporadej(new Locale("en", "US"));
    }
}