import java.util.*;
public class AerolinkyImpl implements Aerolinky
{
	String nazev,sidlo;
	HashMap lety;

	public AerolinkyImpl(String nazev,String sidlo)
	{
		this.nazev=nazev;
		this.sidlo=sidlo;
		lety=new HashMap();
	}
	
	public void pridejLet(String kam,int kolik)
	{
		lety.put(kam,new LetImpl(sidlo,kam,kolik));
	}
	
	public void zrusLet(String kam)throws NeniLet
	{
		if(!lety.containsKey(kam))throw new NeniLet("Nelze zrusit let do "+kam+". Neletame tam\n");
		lety.remove(kam);
	}

	public void rezervuj(String kam, String kdo,int kolik)throws NeniLet, LetObsazen
	{
		if(!lety.containsKey(kam))throw new NeniLet("Do "+kam+" neletame\n");
		LetImpl l=(LetImpl)lety.get(kam);
		l.rezervuj(kdo,kolik);
	}
	
	public void zrus(String kam, String kdo) throws NeniLet,NeniRezervace
	{
		if(!lety.containsKey(kam))throw new NeniLet("Do "+kam+" neletame\n");
		LetImpl l=(LetImpl)lety.get(kam);
		l.zrusRezervace(kdo);
	}
	
	public String toString()
	{
		String rv=new String("Spolecnost "+nazev+" se sidlem "+sidlo+"\n-------------------");
		for(Iterator it=lety.keySet().iterator();it.hasNext();)
		{
			String kam=(String)it.next();
		 	LetImpl l=(LetImpl)lety.get(kam);
			rv+=l;
		}
		rv+="\n--------------------\n";
		return rv;
	}
	
	public void vypis()
	{
		System.out.println(this.toString());
	}
}

