import junit.framework.*;
import java.util.*;

public class TestAerolinky extends TestCase
{
	Aerolinky delta;
	LetImpl brnoPraha;
	
	
	public static void main(String[] args)
	{
		junit.textui.TestRunner.run(TestAerolinky.class);
	}
	
	public void setUp()
	{
		delta=new AerolinkyImpl("Delta", "Brno");
		brnoPraha=new LetImpl("Brno","Praha",2);
	}

	public void testLetRezervuj()
	{
		brnoPraha=new LetImpl("Brno","Praha",3);
		try
		{
	  	 brnoPraha.rezervuj("Vrabcak",3);
		}
		catch(LetObsazen obsazeno)
		{
		 fail("Prazdny let je obsazen => CHYBA!!\n"+brnoPraha);
		}
		try
		{
		 brnoPraha.rezervuj("Orel",1);
		}
		catch(LetObsazen obsOk)
		{
		 System.out.println("Zkontrolujte spravnost obsazeni Letadla:");
		 brnoPraha.vypis();
		 return;
		}
		
		fail("Lze rezervovat misto v plne letadle => CHYBA!!\n"+brnoPraha);
				
	}

	public void testLetZrusRezervaci()
	{
		brnoPraha=new LetImpl("Brno","Praha",2);
		try
		{
			brnoPraha.rezervuj("Datel",1);
			brnoPraha.rezervuj("Brhlik",1);
			brnoPraha.vypis();
		}
		catch(LetObsazen obs)
		{
			fail("Nutno overit spravnost Let.zrusRezervace - chyba v Let.rezervuj");
		}
		
		try
		{
			brnoPraha.vypis();
			System.out.println("Rusim Datel");
			brnoPraha.zrusRezervace("Datel");
		}
		catch(NeniRezervace chybi)
		{
			System.out.println("Nelze zrusit rezervaci Datel v letu:\n");
		}
		
		try
		{
			brnoPraha.vypis();
			brnoPraha.zrusRezervace("Kondor");
			fail("Lze zrusit neexistujici rezervaci (Kondor) => CHYBA!!");
		}
		catch(NeniRezervace chybiOk)
		{
			System.out.println("Pokud chybi smysluplny popis vyjimky NeniRezrevace:\n"+chybiOk+"\n");
			return;
		}
	}

	public void testLetToString()
	{
		brnoPraha=new LetImpl("Brno","Praha",2);
		System.out.println("Pokud chybi vypis letu => CHYBA!!(v letu nejsou rezervace):\n");
		System.out.println(brnoPraha);
	}

	public void testVypis()
	{
		Aerolinky pokus=new AerolinkyImpl("Zkouska","Nikde");
		pokus.pridejLet("Nikam",2);
		pokus.vypis();
		System.out.println("Pokud nebyl videt vypis spolecnosti Zkouska se sidlem Nikde a jednim letem Nikam s kapacitou 2 => CHYBA");
	}

	public void testAerolinkyPridejLet()
	{
		Aerolinky csa=new AerolinkyImpl("CSA","Brno");
		csa.pridejLet("Praha", 2);
		csa.vypis();
		csa.pridejLet("Viden",10);
		System.out.println("Pokud nebyly videt 2 vypisy o CSA se sidlem Brno a s prazdnymi lety do Prahy a do Prahy a Vidne => CHYBA");
	}

	public void testAerolinkyZrusLet()
	{
		Aerolinky fisher=new AerolinkyImpl("Fisher","Praha");
		fisher.pridejLet("Brno",2);
		fisher.vypis();
		try
		{
			fisher.zrusLet("Brno");
		}
		catch(NeniLet neni1)
		{
			fail("Nepridal se let. Nutno manualne proverit metodu Aerolinky.zrusLet(...) => CHYBA");
		}
		fisher.vypis();
		try
		{
			fisher.zrusLet("Brno");
			fail("Lze zrusit neexistujici let => CHYBA");
		}
		catch(NeniLet neni2)
		{
			System.out.println("Ruseni letu OK");
		}

		System.out.println("Pokud nebyly videt 2 vypisy o FisherAir se sidlem Praha a s prazdnym letem do Brna a bez letu => CHYBA");
	}
		

	public void testAerolinkyRezervuj()
	{
		Aerolinky delta=new AerolinkyImpl("Delta","Praha");
		
		delta.pridejLet("Viden",1);
		try
		{
			delta.rezervuj("Viden","Sokolik",1);
			delta.vypis();
		}
		catch(NeniLet neni)
		{
			fail("Spatne seznam letu - nutno manualne proverit Aerolinky.rezervuj(...) => CHYBA ");
		}
		catch(LetObsazen obs)
		{
			fail("Obsazen pradny let => CHYBA");
		}
		try
		{
			delta.rezervuj("Viden","Drozd",1);
			fail("Lze rezervovat misto v plnem letadle => CHYBA");
		}
		catch(NeniLet neni1)
		{
			fail("Spatne seznam letu");
		}
		catch(LetObsazen obs1)
		{
			delta.vypis();
			System.out.println("Predchozi vypis mel obsahovat 2x rezervaci jednoho mista do Vidne se spolecnosti Delta");
		}
	}			
	
	public void testAerolinkyZrus()
	{
		Aerolinky aerol=new AerolinkyImpl("Jestrab Air","Brno");
		aerol.pridejLet("Zdar",1);
		
		try
		{
			aerol.rezervuj("Zdar","Vrabec",1);
		}
		catch(NeniLet nl1)
		{
			aerol.vypis();
			fail("Nutno overit Aerolinky.zrus - nelze provest rezervaci - chybi existujici Let => CHYBA");
		}
		catch(LetObsazen obs1)
		{
			aerol.vypis();
			fail("Nutno overit Aerolinky.zrus - nelze provest rezervaci - let do Zdaru je obsazen => CHYBA");
		}	
		aerol.vypis();
		System.out.println("Vypis 1 rezervace do Zdaru");	
		try
		{
			aerol.zrus("Zdar","Vrabec");
		}
		catch(NeniLet nl2)
		{
			aerol.vypis();
			fail("Nelze zrusit rezervaci - neni let do Zdaru => CHYBA");
		}
		catch(NeniRezervace nr1)
		{
			aerol.vypis();
			fail("Neni rezervace na jmeno Vrabec => CHYBA");
		}
		aerol.vypis();
		System.out.println("Vypis prazdny seznam rezervaci pro Zdar");
		
		try
		{
			aerol.zrus("Zdar","Vrabec");
			fail("Lze zrusit neexistujici let => CHYBA");
		}
		catch(NeniLet nl3)
		{
			aerol.vypis();
			fail("Nutno proverit Aerolinky.zrus() - chybi destinace Zdar => CHYBA");
		}
		catch(NeniRezervace nr2)
		{
			aerol.vypis();
		}
		
		try
		{
			aerol.rezervuj("Zdar","Vrabec",1);
			aerol.vypis();
			aerol.zrus("Viden","Vrabec");
		}
		catch(NeniLet nl4)
		{
			aerol.vypis();
		}
		catch(NeniRezervace nr3)
		{
			fail("Nutno proverit Aerolinky.zrus() - chybi rezervace Vrabec => CHYBA");
		}
	}
		
	public void tearDown()
	{
		
	}
}
