
/**
 * @author: Petr Adamek <petr.adamek@bilysklep.cz>
 */
public class UniversityTest extends junit.framework.TestCase {

    public static void main(String args[]) {
	junit.textui.TestRunner.run(UniversityTest.class);
    }

    static private final String PB162_CODE = "PB162";
    static private final String PB162_NAME = "Programovn v jazyce Java";
    static private final String PB162_DESCRIPTION = "Bezva kurs";
    static private final String PB162A_NAME = "pln jin nzev";
    static private final String PB162A_DESCRIPTION = "Jin popis";
    static private final String PB138_CODE = "PB138";
    static private final String PB138_NAME = "Modern znakovac jazyky a jejich aplikace";
    static private final String PB138_DESCRIPTION = "Taky bezva kurs";

    static private final String PV108_CODE = "PV108";
    static private final String PV108_NAME = "Environmentalistika";
    static private final String PV108_DESCRIPTION = "Taky bezva kurs";

    static private final String XXX_CODE = "I002";
    static private final String XXX_NAME = "Nvrh algoritm I";
    static private final String XXX_DESCRIPTION = "Taky bezva kurs";

    // ===============================================================
    // Test tdy CourseImpl
    // ===============================================================
    
    Course coursePB162;
    Course coursePB162a;
    Course coursePB138;
    
    private void verifyCourseImpl(int points) {
	try {
    	    loadCourseImpl();
	} 
	catch (junit.framework.AssertionFailedError e)
	{
	    fail("Nelze otestovat pro nedodren zadn (ped hodnocenm opravte) !!!!! ["+ points +"]");
	}
    }

    public void testCourseImplConstructor_10() {
	loadCourseImpl();
    }
    
    public void testCourseEquals_4() {
	int points = -4;
	verifyCourseImpl(points);
	assertTrue("Metoda CourseImpl.equals(Object o) vrac false pro stejn kurzy ["+points+"]",coursePB162.equals(coursePB162a));
	assertFalse("Metoda CourseImpl.equals(Object o) vrac true pro rzn kurzy ["+points+"]",coursePB162.equals(coursePB138));
    }

    public void testCourseHashCode_4() {
	int points = -4;
	verifyCourseImpl(points);
	assertTrue("Metoda CourseImpl.hashCode() vrac rzn hodnoty pro stejn kurzy ["+points+"]",coursePB162.hashCode() == coursePB162a.hashCode());
	assertTrue("Metoda CourseImpl.hashCode() pravdpodobn vrac konstantu ["+ -1 +"]",coursePB162.hashCode() != coursePB138.hashCode());
    }

    public void testCourseComparable_4() {
	int points = -4;
	verifyCourseImpl(points);
	assertTrue("Tda CourseImpl neimplementuje rozhran Comparable ["+points+"]",coursePB162 instanceof Comparable);
    }

    public void testCourseGetCode_2() {
	int points = -2;
	verifyCourseImpl(points);
	assertTrue("Metoda CourseImpl.getCode() nevrac sprvnou hodnotu ["+points+"]",coursePB162.getCode().equals(PB162_CODE));
	assertTrue("Metoda CourseImpl.getCode() nevrac sprvnou hodnotu ["+points+"]",coursePB138.getCode().equals(PB138_CODE));
    }
    
    public void testCourseGetName_2() {
	int points = -2;
	verifyCourseImpl(points);
	assertTrue("Metoda CourseImpl.getName() nevrac sprvnou hodnotu ["+points+"]",coursePB162.getName().equals(PB162_NAME));
	assertTrue("Metoda CourseImpl.getName() nevrac sprvnou hodnotu ["+points+"]",coursePB138.getName().equals(PB138_NAME));
    }

    public void testCourseGetDescription_2() {
	int points = -2;
	verifyCourseImpl(points);
	assertTrue("Metoda CourseImpl.getDescription() nevrac sprvnou hodnotu ["+points+"]",coursePB162.getDescription().equals(PB162_DESCRIPTION));
	assertTrue("Metoda CourseImpl.getDescription() nevrac sprvnou hodnotu ["+points+"]",coursePB138.getDescription().equals(PB138_DESCRIPTION));
    }

    public void testCourseCompareTo_4() {
	int points = -4;
	verifyCourseImpl(points);
	java.lang.reflect.Method compareToMethod = null;

	Class[] paramTypes = { new Object().getClass() };
	try {
	    compareToMethod = coursePB162.getClass().getMethod("compareTo",paramTypes);
    	}
	catch (NoSuchMethodException e)
	{
	    fail("Chyb metoda CourseImpl.compareTo(Object o) ["+points+"]");
	}

	try {
	    Object[] parameters1 = { coursePB162a };
	    assertTrue("Metoda CourseImpl.compareTo(Object o) vrac nenulov vsledek pro stejn kurzy ["+points+"]",
		((Integer) compareToMethod.invoke(coursePB162,parameters1)).intValue() == 0);
	
	    Object[] parameters2 = { coursePB138 };
	    assertTrue("Metoda CourseImpl.compareTo(Object o) nead kurz PB162 za PB138 ["+points+"]",
		((Integer) compareToMethod.invoke(coursePB162,parameters2)).intValue() > 0);
	}
	catch (Exception e) {
	    throw new RuntimeException("Voln metody CourseImpl.compareTo() selhalo",e);
	}
    }

    /** 
      * Tato metoda se pomoc Java reflection API pokus zavst tdu CourseImpl a 
      *	vytvoit nkolik instanc pomoc pedepsanho konstruktoru. 
      */
    private void loadCourseImpl() {
	
	int points = -10;

	Class courseImplClass = null;

	try {
	    courseImplClass = Class.forName("CourseImpl");
	}
	catch (ClassNotFoundException e)
	{
	    fail("Tda CourseImpl nenalezena ["+ points +"]");
	}

	Class stringClass = new String().getClass();
	Class[] constructorParameters = { stringClass, stringClass, stringClass };

	java.lang.reflect.Constructor courseImplConstructor = null;
	try {
	    courseImplConstructor = courseImplClass.getConstructor(constructorParameters);
    	}
	catch (NoSuchMethodException e)
	{
	    fail("Chyb konstruktor CourseImpl(String code, String name, String description) [" + points + "]");
	}

	try {
	    String[] parameters1 = { PB162_CODE, PB162_NAME,  PB162_DESCRIPTION  };
	    String[] parameters2 = { PB162_CODE, PB162A_NAME, PB162A_DESCRIPTION };
	    String[] parameters3 = { PB138_CODE, PB138_NAME,  PB138_DESCRIPTION  };
	    coursePB162   = (Course) courseImplConstructor.newInstance(parameters1);
	    coursePB162a = (Course) courseImplConstructor.newInstance(parameters2);
	    coursePB138   = (Course) courseImplConstructor.newInstance(parameters3);
	}
	catch (ClassCastException e) {
	    fail("Tda CourseImpl neimplementuje rozhran Course ["+points+"]");
	}
	catch (Exception e)
	{
	    if (e instanceof RuntimeException) {
		throw (RuntimeException) e;
	    }
	    else {
		throw (RuntimeException) new RuntimeException("Can't create instace of class CourseImpl").initCause(e);
	    }
	}
    }
    
    // ===============================================================
    // Test tdy UniversityImpl
    // ===============================================================

    University university;

    private void verifyUniversityImpl(int points) {
	try {
    	    loadUniversityImpl();
	}
	catch (junit.framework.AssertionFailedError e)
	{
	    fail("Nelze otestovat pro nedodren zadn (ped hodnocenm opravte) !!!!! ["+ points +"]");
	}
    }

    public void testUniversityImplConstructor_10() {
	loadUniversityImpl();
    }

    final static int containsPoints = -4;

    public void testUniversityImplContainsCourse_4() {
	int points = containsPoints;
	verifyUniversityImpl(points);
        verifyCourseImpl(points);

	assertFalse("Metoda UniversityImpl.containsCourse() vrac true pro njak kurs, akoliv zatm dn nebyl vytvoen ["+ points +"]",university.containsCourse(coursePB162));
    }

    public void testUniversityImplCreateCourse_5() {
	int points = -5;
	verifyUniversityImpl(points);
	Course c1 = null;
	
	try {
	    c1 = university.createCourse(PB162_CODE, PB162_NAME,  PB162_DESCRIPTION);
	} 
	catch (InvalidCourseException e) {
	    fail("Pi pokusu o vytvoen prvnho kurzu po vytvoen instance" + 
	    " UniversityImpl je vyvolna vjimka InvalidCourseException ["+ points +"]");
	}

	try {
	    university.createCourse(PB162_CODE, PB162A_NAME,  PB162A_DESCRIPTION);
	    fail("Podailo se vytvoit dal kurz se stejnm nzvem ani by byla vyvolna vjimka InvalidCourseException ["+ points +"]");
	}
	catch (InvalidCourseException e) {
	    // Byla sprvn vyvolna vjimka
	}	

	assertTrue("Pro vloen kurz vrac metoda UniversityImpl.containsCourse(Course c) hodnotu false; " + 
	    "nefunguje metoda UniversityImpl.createCourse(...) ["+ points +"] " + 
	    "nebo UniversityImpl.containsCourse(Course c) ["+ containsPoints +"]. ",university.containsCourse(c1));
    }

    public void testUniversityImplRemoveCourse_5() {
	int points = -5;
	verifyUniversityImpl(points);
        verifyCourseImpl(points);
	Course c1 = null;
	
	try {
            university.removeCourse(coursePB162);
            fail("Podailo se odebrat neexistujc kurz ani by byla vyvolna vjimka InvalidCourseException ["+ points +"]");
        }
        catch (InvalidCourseException e) {
            // Byla sprvn vyvolna vjimka
        }

	try {
	    c1 = university.createCourse(PB162_CODE, PB162_NAME,  PB162_DESCRIPTION);
	} 
	catch (Exception e) {
	    throw (RuntimeException) new RuntimeException(
		"Odebrn kurz nelze otestovat, pokus o vloen kurzu (urenho k odebrn) selhal").initCause(e);
	}

	assertTrue("Odebrn kurz nelze otestovat, nefunguje metoda UniversityImpl.createCourse(...) " + 
	    "nebo UniversityImpl.containsCourse(Course c) ["+ points +"]. ",university.containsCourse(c1));

	try {
            university.removeCourse(c1);
        }
        catch (InvalidCourseException e) {
	    fail("Pi pokusu o odebrn existujcho kurzu je vyvolna vjimka InvalidCourseException ["+ points +"]");
        }
	
	assertFalse("Pro odebran kurz metoda UniversityImpl.contains(Course c) stle vrac true (bu je chyba " +
	"v metod UniversityImpl.removeCourse(Course c) ["+ points +
	"] nebo v metod UniversityImpl.containsCourse(Course c)) ["+ containsPoints +"]",university.containsCourse(c1));

    }

    public void testUniversityImplList_5() {
	int points = -5;
	verifyUniversityImpl(points);

	Course c1;
	Course c2;
	Course c3;
	Course c4;
	
	try {
	    c1 = university.createCourse(XXX_CODE,   XXX_NAME,    XXX_DESCRIPTION);
	    c2 = university.createCourse(PB138_CODE, PB138_NAME,  PB138_DESCRIPTION);
	    c3 = university.createCourse(PB162_CODE, PB162_NAME,  PB162_DESCRIPTION);
	    c4 = university.createCourse(PV108_CODE, PV108_NAME,  PV108_DESCRIPTION);
	}
	catch (Exception e) {
	    throw (RuntimeException) new RuntimeException(
		"Vpis kurz nelze otestovat, pokus o vloen kurzu (urenho k vpisu) selhal").initCause(e);
	}

	java.io.StringWriter s1 = new java.io.StringWriter();
	java.io.StringWriter s2 = new java.io.StringWriter();
	java.io.PrintWriter p1 = new java.io.PrintWriter(s1);
	java.io.PrintWriter p2 = new java.io.PrintWriter(s2);

	university.listCourses(p1);
	p2.println(c1.getCode() + " " + c1.getName());
	p2.println(c2.getCode() + " " + c2.getName());
	p2.println(c3.getCode() + " " + c3.getName());
	p2.println(c4.getCode() + " " + c4.getName());
    
	if (!s1.toString().equals(s2.toString())) {
	    fail("Vpis kurz neodpovd poadavkm zadn ["+ points +"]; msto oekvanho\n\n" +
		s2.toString() + "\nse vypsalo\n\n" + s1.toString());
	}

    }

    /** 
      * Tato metoda se pomoc Java reflection API pokus zavst tdu UniversityImpl a vytvoit jej instanci.
      */
    private void loadUniversityImpl() {
	
	int points = -10;

	Class universityImplClass = null;

	try {
	    universityImplClass = Class.forName("UniversityImpl");
	}
	catch (ClassNotFoundException e)
	{
	    fail("Tda UniversityImpl nenalezena ["+ points +"]");
	}

	try {
	    university = (University) universityImplClass.newInstance();
	}
	catch (ClassCastException e) {
	    fail("Tda UniversityImpl neimplementuje rozhran University ["+points+"]");
	}
	catch (Exception e)
	{
	    if (e instanceof RuntimeException) {
		throw (RuntimeException) e;
	    }
	    else {
		throw (RuntimeException) new RuntimeException("Can't create instace of class UniversityImpl").initCause(e);
	    }
	}
    }    
}