
import java.io.PrintWriter;
/** 
 * University je rozhran, kter reprezentuje univerzitu.
 * Univerzita umouje vytvet nov kurzy, eviduje jejich seznam
 * a umouje s nimi provdt zkladn operace.
 *
 * @author Petr Adamek <xadamek2@fi.muni.cz>
 */
public interface University {

    /** 
     * Tato metoda vytvo nov kurz a zaad jej do seznamu existujcch kurz. 
     * Pokud ji takov kurz existuje (tj. kurz se stejnm kdem), 
     * vygeneruje vjimku InvalidCourseException.
     */    
    public Course createCourse(String code, String name, String description) throws InvalidCourseException;

    /** 
     * Tato metoda vype seznam kurz uspodan podle kd pedmtu do zadanho proudu znak.
     * Kad kurz se vype na samostatn dek, nejdve kd a pak jmno pedmtu oddlen jednou mezerou. Nap.: 
     * PB162 Programovn v jazyce Java
     * PB138 Modern znakovac jazyky a jejich aplikace 
     */
    public void listCourses(PrintWriter p);

    /**
     * Metoda zjist, nachz-li se dan kurz v seznamu existujcch kurz.
     */
    public boolean containsCourse(Course c);

    /**
     * Metoda ze seznamu kurz odstran dan kurz. Pokud dan kurz neexistuje, vygeneruje vjimku InvalidCourseException.
     */
    public void removeCourse(Course c) throws InvalidCourseException;
    
}
