/*

   Doplte do tdy Quaternion metodu putQuaternion, kter pevede sloky
   quaternionu ze slokovho tvaru do algebraickho ve form textovho
   etzce (String), piem se sloky hodnoty 0 nebudou vypisovat.

   Quaterniony jsou rozenm komplexnch sel (ze dvou sloek na tyi).
   C = (c1, c2) :=: C = c1 + i.c2 => Q = (q1, q2, q3, q4) :=: Q = q1 + i.q2 + j.q3 + k.q4 
   S konkrtnmi hodnotami se quaternion pe jak nsleduje
                                              (2, 3, 5, 7) = 2 + 3i + 5j + 7k

   Jako pklad vstupu metody putQuaternion uvdm:
    (11, 0, 0, 0) --> "11"
   (13, 17, 0, 0) --> "13 + 17i"
   (19, 0, 0, 23) --> "19 + 23k"
     (2, 3, 5, 7) --> "2 + 3i + 5j + 7k"

   Dle doplte metodu productQuaternion, kter dosad do vyvolvajcho
   quaternionu souin dvou quaternion, kter dostane jako parametry.

   Pro souin quaternionu se pravideln uvd zpis v algebraick notaci:
     i*i = j*j = k*k = -1
     i*j = k = -j*i
     j*k = i = -k*j
     k*i = j = -i*k

   Tdu Pisemka v balku pisemka nebudete vbec mnit.

*/

package pomocne;

import java.io.*;
import java.util.*;

public class Quaternion{
   private double q1, q2, q3, q4;


   public Quaternion(){
      q1 = 0.0;
      q2 = 0.0;
      q3 = 0.0;
      q4 = 0.0;
   }

   public Quaternion(float qq1){
      q1 = qq1;
      q2 = 0.0;
      q3 = 0.0;
      q4 = 0.0;
   }

   public Quaternion(float qq1, float qq2){
      q1 = qq1;
      q2 = qq2;
      q3 = 0.0;
      q4 = 0.0;
   }

   public Quaternion(float qq1, float qq2, float qq3){
      q1 = qq1;
      q2 = qq2;
      q3 = qq3;
      q4 = 0.0;
   }

   public Quaternion(float qq1, float qq2, float qq3, float qq4){
      q1 = qq1;
      q2 = qq2;
      q3 = qq3;
      q4 = qq4;
   }

   public Quaternion(String wstup){
   int in, is, j;

      q1 = 0.0;
      q2 = 0.0;
      q3 = 0.0;
      q4 = 0.0;
      if(
         !(wstup.equals(""))
      ){
         j = 0;
         in = -1;
         do{
            in = wstup.indexOf(' ', in + 1);
            ++j;
         }while(
            in > 0
         );
         if(
            j < 5
         ){
            is = -1;
            if(
               j > -1               
            ){
               in = wstup.indexOf(' ');
               try{
                  q1 = Float.valueOf(wstup.substring(0, in)).floatValue();
               }catch(NumberFormatException n){
               }
            }
            if(
               j > 0
            ){
               ++in;
               is = wstup.indexOf(' ', in);
               try{
                  q2 = Float.valueOf(wstup.substring(in, is)).floatValue();
               }catch(NumberFormatException n){
               }
            }
            if(
               j > 1
            ){
               ++is;
               in = wstup.indexOf(' ', is);
               try{
                  q3 = Float.valueOf(wstup.substring(is, in)).floatValue();
               }catch(NumberFormatException n){
               }
            }
            if(
               j > 2
            ){
               ++in;
               try{
                  q4 = Float.valueOf(wstup.substring(in)).floatValue();
               }catch(NumberFormatException n){
               }
            }
         }
      }
   }
 
   public void setQuaternion(){
      q1 = 0.0;
      q2 = 0.0;
      q3 = 0.0;
      q4 = 0.0;
   }

   public void setQuaternion(float qq1){
      q1 = qq1;
      q2 = 0.0;
      q3 = 0.0;
      q4 = 0.0;
   }

   public void setQuaternion(float qq1, float qq2){
      q1 = qq1;
      q2 = qq2;
      q3 = 0.0;
      q4 = 0.0;
   }

   public void setQuaternion(float qq1, float qq2, float qq3){
      q1 = qq1;
      q2 = qq2;
      q3 = qq3;
      q4 = 0.0;
   }

   public void setQuaternion(float qq1, float qq2, float qq3, float qq4){
      q1 = qq1;
      q2 = qq2;
      q3 = qq3;
      q4 = qq4;
   }

   public void setQuaternion(String wstup){
   int in, is, j;

      q1 = 0.0;
      q2 = 0.0;
      q3 = 0.0;
      q4 = 0.0;
      if(
         !(wstup.equals(""))
      ){
         j = 0;
         in = -1;
         do{
            in = wstup.indexOf(' ', in + 1);
            ++j;
         }while(
            in > 0
         );
         if(
            j < 5
         ){
            is = -1;
            if(
               j > 0               
            ){
               in = wstup.indexOf(' ');
               try{
                  if(
                     in == -1
                  ){
                     q1 = Float.valueOf(wstup.substring(in)).floatValue();
                  }else{
                     q1 = Float.valueOf(wstup.substring(0, in)).floatValue();
                  }
               }catch(NumberFormatException n){
                  System.err.print("V 1. slozce quaternionu nebo za ni byly neobvykle znaky.\n");
               }
            }
            if(
               j > 1
            ){
               ++in;
               is = wstup.indexOf(' ', in);
               try{
                  if(
                     is == -1
                  ){
                     q2 = Float.valueOf(wstup.substring(in)).floatValue();
                  }else{
                     q2 = Float.valueOf(wstup.substring(in, is)).floatValue();
                  }
               }catch(NumberFormatException n){
                  System.err.print("V 2. slozce quaternionu nebo za ni byly neobvykle znaky.\n");
               }
            }
            if(
               j > 2
            ){
               ++is;
               in = wstup.indexOf(' ', is);
               try{
                  if(
                     in == -1
                  ){
                     q3 = Float.valueOf(wstup.substring(in)).floatValue();
                  }else{
                     q3 = Float.valueOf(wstup.substring(is, in)).floatValue();
                  }
               }catch(NumberFormatException n){
                  System.err.print("V 3. slozce quaternionu nebo za ni byly neobvykle znaky.\n");
               }
            }
            if(
               j > 3
            ){
               ++in;
               try{
                  q4 = Float.valueOf(wstup.substring(in)).floatValue();
               }catch(NumberFormatException n){
                  System.err.print("Ve 4. slozce quaternionu nebo za ni byly neobvykle znaky.\n");
               }
            }
         }else{
            System.err.print("Prilis mnoho slozek.\n");
         }
      }
   }

   public void sumQuaternion(Quaternion aa, Quaternion bb){
      q1 = aa.q1 + bb.q1;
      q2 = aa.q2 + bb.q2;
      q3 = aa.q3 + bb.q3;
      q4 = aa.q4 + bb.q4;
   }
 
   public String putQuaternion(){
      return "(" + q1 + ", " + q2 + ", " + q3 + ", " + q4 + ")";
   }

   public void productQuaternion(Quaternion aa, Quaternion bb){
      
   }
}