import java.util.*;

public class Firma {
	private String nazev;
	private List vydane, prijate;
	
	public Firma(String n) {
		nazev = n;
		vydane = new ArrayList();
		prijate = new ArrayList();
	}
	
	public String toString() {
		return "Firma nazev="+nazev;
	}

	protected void addFakturaPrijata(Faktura f) {
		prijate.add(f);
	}
	
	protected void addFakturaVydana(Faktura f) {
		vydane.add(f);
	}
	
	public Faktura vydejFakturu(Firma komu) {
		Faktura f = new Faktura(komu);
		vydane.add(f);
		komu.addFakturaPrijata(f);
		return f;
	}
	
	protected Iterator fakturyIterator(boolean vstup) {
		if(vstup) {
			return prijate.iterator();
		} else {
			return vydane.iterator();
		}
	}
			
	public double getZaklad22(boolean vstup) {
		Iterator i = fakturyIterator(vstup);
		double suma = 0;
		while (i.hasNext()) {
			Faktura f = (Faktura)i.next();
			suma += f.getZaklad22();
		}
		return suma;
	}

	public double getZaklad5(boolean vstup) {
		Iterator i = fakturyIterator(vstup);
		double suma = 0;
		while (i.hasNext()) {
			Faktura f = (Faktura)i.next();
			suma += f.getZaklad5();
		}
		return suma;
	}

	public  double getDan22(boolean vstup) {
		return getZaklad22(vstup)*.22;
	}

	public  double getDan5(boolean vstup) {
		return getZaklad5(vstup)*.05;
	}

	public double getCelkemVcDPH(boolean vstup) {
		return getZaklad5(vstup)+
			getZaklad22(vstup)+
			getDan5(vstup)+
			getDan22(vstup);
	}
	
	public double kolikOdvestDPH() {
		return getDan(false) - getDan(true);
	}
		
	protected double getDan(boolean vstup) {
		return getDan5(vstup) + getDan22(vstup);
	}

	public void danovePriznani() {
		double odvest = kolikOdvestDPH();
		if(odvest >= 0) {
			System.out.println("Firma "+this+" odvede FU "+odvest+" Kc DPH.");
		} else {
			System.out.println("Firma "+this+" dostane zpet od FU "+(-odvest)+" Kc DPH.");
		}
	}
	
}	
