import java.util.*;

public class Sklad {
	private String nazev;
	private double nosnost, volnaNosnost;
	private Map skladiste;
	
	public Sklad(String n, double k) {
		nazev = n;
		nosnost = k;
		volnaNosnost = k;
		skladiste = new HashMap();
	}
	
	public String toString() {
		return "Sklad ["+nazev+"]";
	}

	public double vyskladni(DruhZbozi dz, double jednotek) {
		Double veSkladu = (Double)skladiste.get(dz);
		double vs = 0;
		if(veSkladu != null)
			vs = veSkladu.doubleValue();
		if(jednotek <= vs) {
			skladiste.put(dz, new Double(vs - jednotek));
			volnaNosnost += jednotek * dz.getJednotkovaHmotnost();
			return jednotek;
		} else {
			skladiste.put(dz, new Double(0));
			volnaNosnost += vs * dz.getJednotkovaHmotnost();
			return vs;
		}
	}
	
	public double naskladni(DruhZbozi dz, double jednotek) {
		if(volnaNosnost < jednotek * dz.getJednotkovaHmotnost())
			throw new PrilisTezkeException(dz, jednotek, volnaNosnost);
		return -vyskladni(dz, -jednotek);
	}
	
	public double presun(DruhZbozi dz, double jednotek, Sklad kam) {
		double k = vyskladni(dz, jednotek);
		return kam.naskladni(dz, k);
	}
	
	public void stav() {
		System.out.println(this);
		for (Iterator i = skladiste.entrySet().iterator(); i.hasNext(); ) {
			Map.Entry me = (Map.Entry)i.next();
			DruhZbozi dz = (DruhZbozi)me.getKey();
			double mnozstvi = ((Double)me.getValue()).doubleValue();
			System.out.println(dz+" je ve skladu "+mnozstvi);
		}
	}
	
}	
