package tomp.ucebnice.junit;

public class JUnitDemo extends junit.framework.TestCase {
    
    private Zlomek x, y, soucet, xx;
    
    public void setUp() {
         x = new Zlomek(1,2);
         xx = new Zlomek(6, 12);
         y = new Zlomek(1,3);
         soucet = new Zlomek(5,6);
    }
    
    public void testRovna() {
        assertEquals("1/2 a 6/12 se musi rovnat", x, xx);
    }
    
    public void testSoucetRovna() {
        Zlomek s = Zlomek.soucet(x, y);
        assertEquals("Soucet 1/2 a 1/3 se musi rovnat 5/6", soucet, s);
    }
    
    public void testNelzeVytvorit() {
        try {
            Zlomek bad = new Zlomek(10,0);
            fail("Zlomek s nulovym jmenovatelem nemel jit vytvorit");
        } catch(AssertionError ae) {
            // OK!
        }
    }
    
    public void tearDown() {
    }
    
}
class Zlomek {
    
    int citatel, jmenovatel;
    
    public Zlomek(int c, int j) {
        
        assert j != 0;
        
        citatel = c;
        jmenovatel = j;
    }
    
    public boolean equals(Object o) {
        if (o instanceof Zlomek) {
            Zlomek z = (Zlomek)o;
            return citatel * z.jmenovatel == z.citatel * jmenovatel;
        } else 
            return false;
    }
    
    public static Zlomek soucet(Zlomek a, Zlomek b) {
        return new Zlomek(a.citatel*b.jmenovatel + b.citatel*a.jmenovatel, 
                          a.jmenovatel*b.jmenovatel);
    }
    
    public String toString() {
        return citatel+"/"+jmenovatel;
    }
}
   