package tomp.ucebnice.reflexe;

import java.lang.reflect.*;

interface Rozhrani1 {
}
class Objekt1 implements Rozhrani1 {
    int i;
    long j;
    String s;
    Objekt1(int i, long j, String s) {
        this.i = i;
        this.j = j;
        this.s = s;
    }
    void spust() {
        System.out.println("Vyvolana metoda spust() tridy "+getClass().getName());
    }
    public String toString() {
        return "Toto jsem pridal. "+super.toString();
    }
}
interface Rozhrani2 {
}
class Objekt2 extends Objekt1 implements Rozhrani2 {
    Objekt2(int i, long j, String s) {
        super(i, j, s);
    }
    public String toString() {
        return "Toto jsem pridal v tride Objekt2. "+super.toString();
    }
}

public class Reflexe {
    public static void main(String args[]) throws Exception {
        Objekt1 o1 = new Objekt1(1, 2, "Objekt1");
        Objekt2 o2 = new Objekt2(2, 20, "Objekt2");
        System.out.println("o2 instanceof Objekt2? " + (o2 instanceof Objekt2));
        System.out.println("o2 instanceof Objekt1? " + (o2 instanceof Objekt1));
        System.out.println("o2 instanceof Rozhrani2? " + (o2 instanceof Rozhrani2));

        Class cr1a = o1.getClass();
        Class cr1b = Class.forName("tomp.ucebnice.reflexe.Objekt1");
        Class cr1c = Objekt1.class;
        System.out.println("o1.getClass() == Class.forName() == Objekt1.class? "
            + (cr1a == cr1b && cr1b == cr1c));

        System.out.println("o2 rozsiruje:");
        Class r2superClass = o2.getClass().getSuperclass();
        System.out.println(r2superClass);

        System.out.println("o2 implementuje:");
        Class[] r2intfs = o2.getClass().getInterfaces();
        for (int i = 0; i < r2intfs.length; i++) {
            System.out.println(r2intfs[i]);
        }

        System.out.println("o2.getClass().isAssignableFrom(o1.getClass())? "
            + o2.getClass().isAssignableFrom(o1.getClass()));
        System.out.println("o1.getClass().isAssignableFrom(o2.getClass())? "
            + o1.getClass().isAssignableFrom(o2.getClass()));

        System.out.println("Rozhrani1.class.isInterface()? "
            + Rozhrani1.class.isInterface());

        System.out.println("Integer.class.isPrimitive()? "
            + Integer.class.isPrimitive());

        System.out.println("Integer.TYPE.isPrimitive()? "
            + Integer.TYPE.isPrimitive());

    }
}
