package tomp.dyngraphs;

/**
 * The <code>Demo</code> class is an demonstration entry point
 * to the world of dynamically implemented graphs
 * in the <code>tomp.dyngraphs</code> package.
 */
public class Demo {

    public static void main(String[] args) throws tomp.graphs.GraphException {

        Graph g = new DynGraph();

        Node praha = new DynNode("Praha");
        Node brno = new DynNode("Brno");
        Node ostrava = new DynNode("Ostrava");

        Node bratislava = new DynNode("Bratislava");

        g.addNode(praha);
        g.addNode(brno);
        g.addNode(ostrava);

        g.setEdge(praha, brno);
        g.setEdge(praha, ostrava);
        g.setEdge(brno, ostrava);

        GraphPrinter.print(g);

        brno.setName("Velke Brno");

        GraphPrinter.print(g);

        // povolime-li nasledujici prikaz, skonci vyjimkou,
        // ze uzel Bratislava v grafu neni.

        // g.setEdge(brno, bratislava);
    }
}