package tomp.dyngraphs;

import tomp.graphs.GraphException;

import java.util.*;

/**
 * The <code>GraphPrinter</code> is a class containing methods for printing dynamic graphs
 */
public class GraphPrinter {

    /**
     * Prints the provided graph to the <code>System.out</code>.
     * @param g Graph to be printed
     */
    public static void print(Graph g) {
        try {
            for (Iterator i = g.nodes().iterator(); i.hasNext(); ) {
                Node n = (Node)i.next();

                System.out.print(n.getName());

                Set neighbors = g.neighbors(n);
                if (!neighbors.isEmpty()) {
                    System.out.print(" -> { ");

                    for (Iterator j = neighbors.iterator(); j.hasNext(); ) {
                        Node neighbor = (Node)j.next();

                        System.out.print(neighbor.getName());
                        if (j.hasNext()) {
                            System.out.print(", ");
                        }
                    }
                    System.out.print(" }");
                }
                System.out.println();
            }
            System.out.println("...............");
        } catch(GraphException ge) {
            ge.printStackTrace();
        }
    }
}