package tomp.graphs;

import tomp.graphs.traversal.*;
import java.io.*;

public class Demo {
    public static void main(String[] args)
    throws GraphException, IOException {

        GraphPrinter gp = new GraphPrinter();
        GraphReader gr = new GraphReader();

        Graph f = gr.readMatrixGraph(new File(args[0]));

        gp.print(f);

        f.setEdge(1, 2);
        f.removeEdge(0, 1);

        gp.print(f);

        GraphWriter gw = new GraphWriter();
        gw.write(f, new File(args[1]));

        WeightedGraph wg = new WeightedMatrixGraph(5);
        wg.setEdgeWeight(0, 1, 3);
        wg.setEdgeWeight(1, 0, 4);
        wg.setEdgeWeight(1, 3, 7);
        wg.setEdgeWeight(3, 4, 1);
        wg.setEdgeWeight(4, 0, 2);
        gp.print(wg);

//  Rozite tdy GraphReader a GraphWriter tak, aby umly natat a ukldat
//  hranov ohodnocen grafy (objekty WeightedGraph)
//  a dalo se zavolat:
//      gw.write(wg, new File("weighted-graph.grf"));

// Pozn.: pouitm stvajcho GraphWriteru bychom mohli
// ohodnocen graf tak uloit, ale byl by chpn jako neoohodnocen,
// hodnocen by se neuloilo
// nap.:
//
        gw.write(wg, new File("weighted-graph.grf"));

// ... pi souasn podob tdy GraphWriter ulo graf jako neohodnocen

        new Traversal().depthFirst(wg, 0);

// deklarujte tdu MyHandler tak, aby nsledujc prochzen do hloubky
// fungovalo

//        new HandlerTraversal().depthFirst(wg, 0, new MyHandler());

//  Rozite tdu Traversal do MyTraversal tak,
//  aby umla i prochzen grafu do ky
//  a dalo se zavolat jak:

//        new MyTraversal().breadthFirst(f, 0);

//  tak i s posluchaem udlost (handlerem):

//        new MyTraversal().breadthFirst(f, 0, new MyHandler());

    }
}
