package tomp.graphs;
import java.io.*;

public class GraphPrinter {
    public void print(Graph g) {
        try {
            System.out.print("...............  : ");
            for (int i = 0; i < g.getNodeCount(); i++) {
                System.out.print(i+" ");
            }    
            System.out.println();
            for (int i = 0; i < g.getNodeCount(); i++) {
                System.out.print("Edges from node "+i+": ");
                for (int j = 0; j < g.getNodeCount(); j++) {
                    System.out.print( g.hasEdge(i, j) ? "* " : "- ");
                }
                System.out.println();
            }
        } catch(GraphException ge) {
            ge.printStackTrace();
        }
    }
    
    public void print(WeightedGraph g) {
        try {
            System.out.print("...............  : ");
            for (int i = 0; i < g.getNodeCount(); i++) {
                System.out.print(" "+i+"  ");
            }    
            System.out.println();
            for (int i = 0; i < g.getNodeCount(); i++) {
                System.out.print("Edges from node "+i+": ");
                for (int j = 0; j < g.getNodeCount(); j++) {
                    if (g.hasEdge(i, j))
                        System.out.print( g.getEdgeWeight(i, j) + " ");
                    else 
                        System.out.print( " -  ");
                }
                System.out.println();
            }
        } catch(GraphException ge) {
            ge.printStackTrace();
        }
    }
}