package tomp.graphs;
import java.io.*;

public class GraphReader {

    public MatrixGraph readMatrixGraph(File f)
    throws IOException, NumberFormatException {
        
        BufferedReader br = new BufferedReader(new FileReader(f));
        String s = br.readLine();
        int nodeCount = Integer.parseInt(s);
        
        MatrixGraph g = new MatrixGraph(nodeCount);
        
        for (int i = 0; i < nodeCount; i++) {
            s = br.readLine();
            for (int j = 0; j < nodeCount; j++) {
                try {
                    if (s.charAt(j) == '*')
                        g.setEdge(i, j);
                } catch (GraphException ge) {
                    throw new IOException("Cannot read graph because "+ge.getMessage());
                }
            }
        }
        br.close();
        return g;
    }
}