package tomp.graphs;
import java.io.*;

public class GraphWriter {

    public void write(Graph g, File f) 
    throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(f));
        pw.println(g.getNodeCount());
        for (int i = 0; i < g.getNodeCount(); i++) {
            for (int j = 0; j < g.getNodeCount(); j++) {
                try {
                    pw.print( g.hasEdge(i, j) ? "*" : "-");
                } catch (GraphException ge) {
                    throw new IOException("Cannot write graph because "+ge.getMessage());
                }
            }
            pw.println();
        }
        pw.close();
    }
}