package tomp.graphs;

import java.io.*;

public class MatrixGraph implements Graph {

    protected float[][] grf;
    
    public MatrixGraph(int nodeCount) {
        grf = new float[nodeCount][nodeCount];
    }
    
    public int getNodeCount() {
        return grf.length;
    }
    
    public boolean hasEdge(int node1, int node2) 
    throws GraphException {
        try {
            return grf[node1][node2] > 0;
        } catch(ArrayIndexOutOfBoundsException aioob) {
            throw new GraphException(
                "Cannot test edge between " +node1+ " and "+node2);
        }
    }
    
    public void setEdge(int node1, int node2) 
    throws GraphException {
        try {
            grf[node1][node2] = 1;
        } catch(ArrayIndexOutOfBoundsException aioob) {
            throw new GraphException(
                "Cannot set edge between " +node1+ " and "+node2);
        }
    }

    public void removeEdge(int node1, int node2) 
    throws GraphException {
        try {
            grf[node1][node2] = 0;
        } catch(ArrayIndexOutOfBoundsException aioob) {
            throw new GraphException(
                "Cannot delete edge between " +node1+ " and "+node2);
        }
    }
    
}
    