package tomp.graphs;

import java.io.*;

public class WeightedMatrixGraph extends MatrixGraph implements WeightedGraph {

    public WeightedMatrixGraph(int nodeCount) {
        super(nodeCount);
    }

    public void setEdgeWeight(int node1, int node2, float w) 
    throws GraphException {
        try {
            grf[node1][node2] = w;
        } catch(ArrayIndexOutOfBoundsException aioob) {
            throw new GraphException(
                "Cannot set edge weight between " +node1+ " and "+node2);
        }
    }
    
    public float getEdgeWeight(int node1, int node2) 
    throws GraphException {
        try {
            if (hasEdge(node1, node2))
                return grf[node1][node2];
            else 
                throw new GraphException(
                    "No edge between " +node1+ " and "+node2);
        } catch(ArrayIndexOutOfBoundsException aioob) {
            throw new GraphException(
                "Cannot get edge weight between " +node1+ " and "+node2);
        }
    }
    
}
    