package tomp.graphs.traversal;

import tomp.graphs.*;
import java.io.*;

public class Traversal {

    protected boolean[] visitedNodes;
    protected Graph g;

    public void depthFirst(Graph graph, int startNode) throws GraphException {
        init(graph);
        doNodeDF(startNode);
    }

    protected void init(Graph graph) {
        g = graph;
        visitedNodes = new boolean[g.getNodeCount()];
    }

    protected boolean doNodeDF(int node) throws GraphException {
        boolean cont = true;
        if (notVisited(node)) {
            cont = visit(node);
            visitedNodes[node] = true;
            for (int j = 0; j < g.getNodeCount() && cont; j++) {
                if (g.hasEdge(node, j)) {
                    cont = doNodeDF(j);
                }
            }
        }
        return cont;
    }

    protected boolean visit(int node) throws GraphException {
        System.out.println("visiting node="+node);
        return true; // vdy pokraovat dle
    }

    protected boolean notVisited(int node) {
        return !visitedNodes[node];
    }
}