package tomp.searching2;

public class Demo {

    private static final float[] prvky = { 5, 6, 4, 3, 1, 2 };
    private static final float[] prvkySerazene = { 1, 5, 10, 11, 12, 13};

    public static void main(String[] args) {
        LinearSearcher ls = new LinearSearcher();
        BinarySearcher bs = new BinarySearcher();
        LinearSearcherMinMax lsmm = new LinearSearcherMinMax();
        BinarySearcherMinMax bsmm = new BinarySearcherMinMax();

        System.out.println("Linearne:");
        print(prvky);

        ls.readFromKbd();
        doDemoSearch(ls, 4);
        doDemoSearch(ls, 10);

        lsmm.readFromKbd();
        doDemoSearchMinMax(lsmm);

        System.out.println("\nBinarne:");
        print(prvkySerazene);

        bs.readFromKbd();
        doDemoSearch(bs, 4);
        doDemoSearch(bs, 13);

        bsmm.readFromKbd();
        doDemoSearchMinMax(bsmm);
    }

    public static void doDemoSearch(Searcher s, float what ) {
        System.out.println("Index prvku " + what + " = " + s.indexOf(what));
        System.out.println("Je tam " + what + "? " + s.contains(what));
    }

    public static void doDemoSearchMinMax(SearcherMinMax smm) {
        System.out.println("Index minima = " + smm.indexOfMin());
        System.out.println("Index maxima = " + smm.indexOfMax());
    }

    public static void print(float[] fa) {
        for (int i = 0; i < fa.length; i++) {
            System.out.print(fa[i]+", ");
        }
        System.out.println();
    }
}
