package tomp.ucebnice.casovac;

import java.util.Timer;
import java.util.TimerTask;

class PevnaProdleva extends Casovac {
    int pocet;
    long perioda;
    PevnaProdleva(int pocet, long perioda) {
        this.pocet = pocet;
        this.perioda = perioda;
    }
    void spust() {
        final Casovac casovac = this;
        schedule(new TimerTask() {
                    public void run() {
                        System.out.println(
                            casovac.getClass().getName() + " " + pocet--);
                        if (pocet < 0)
                            casovac.cancel();
                    }
                 }, 0, perioda );
    }
}
class PevnaPerioda extends PevnaProdleva {
    PevnaPerioda(int pocet, long perioda) {
        super(pocet, perioda);
    }
    void spust() {
        final Casovac casovac = this;
        scheduleAtFixedRate(new TimerTask() {
                    public void run() {
                        System.out.println(
                            casovac.getClass().getName() + " " + pocet--);
                        if (pocet < 0)
                            casovac.cancel();
                    }
                 }, 0, perioda );
    }
}
class SpustJednou extends Casovac {
    long prodleva;
    SpustJednou(long prodleva) {
        this.prodleva = prodleva;
    }
    void spust() {
        final Casovac casovac = this;
        schedule(new TimerTask() {
                    public void run() {
                        System.out.println(casovac.getClass().getName());
                        casovac.cancel();
                    }
                 }, prodleva );
    }
}
public class Casovac extends Timer {
    void spust() {};
    public static void main(String args[]) {
        int opakovani = 5, perioda = 1000;
        if (args.length == 2) {
            try {
                opakovani = Integer.parseInt(args[0]);
            } catch (NumberFormatException nfe) {}
            try {
                perioda = Integer.parseInt(args[1]);
            } catch (NumberFormatException nfe) {}
        }
        Casovac[] casovace = {
                                new PevnaProdleva(opakovani, perioda),
                                new PevnaPerioda(opakovani, perioda),
                                new SpustJednou(perioda)
                             };
        for (int i = 0; i < casovace.length; i++) {
            casovace[i].spust();
        }
    }
}
