package tomp.ucebnice.components;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Prvn zpsob definovn a vytven hlavnho okna aplikace:
 * okno je potomkem JFrame (vdy) a vytvo se v metod main
 * t stejn tdy. 
 * Tato metoda je spoutem celho pg.
 */
public class BorderLayoutDemo2 extends JFrame {
	
    public static void main(String[] args) {
	new BorderLayoutDemo2().show();
    }
    
    public BorderLayoutDemo2() {
    	
    	// konstruktor pedka kvli nastaven nzvu okna
    	super("BorderLayoutDemo2");
    	
    	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	
	// toto bude vnitek hlavnho okna
	JPanel p = new JPanel();
	    
	// rozmstn komponent pi okrajch, 
	// podle "svtovch stran"
	p.setLayout(new BorderLayout());
	
	// tento panel bude horni
	JPanel pUpper = new JPanel();

	// tento panel bude spodni
	JPanel pLower = new JPanel();
	
	// do hornho panelu...
	JButton jb1 = new JButton("Prvn v hornm");
	pUpper.add(jb1);
	    
	JButton jb2 = new JButton("Druh v hornm");
	pUpper.add(jb2);
	    
	// do spodnho panelu...
	JButton jb3 = new JButton("Tet ve spodnm");
	pLower.add(jb3);
	    
	JButton jb4 = new JButton("tvrt ve spodnm");
	pLower.add(jb4);
	    
	JButton jb5 = new JButton("Pt ve spodnm");
	pLower.add(jb5);
	
	// panely pidme do hlavnho panelu
	p.add(pUpper, BorderLayout.NORTH);
	p.add(pLower, BorderLayout.SOUTH);
	
	// te teprve pidme panel do hlavnho okna
	setContentPane(p);

        // a upravme velikost, aby se tam vechno velo
	pack();
    }
    
}	
