package tomp.ucebnice.components;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Prvn zpsob definovn a vytven hlavnho okna aplikace:
 * okno je potomkem JFrame (vdy) a vytvo se v metod main
 * t stejn tdy. 
 * Tato metoda je spoutem celho pg.
 */
public class GridBagLayoutDemo1 extends JFrame {
	
    // toto bude vnitek hlavnho okna
    JPanel p = new JPanel();
	    
    // GridBagLayout 
    GridBagLayout gbl = new GridBagLayout();

    // omezen pro umisovn komponent
    GridBagConstraints c = new GridBagConstraints();
	
    public static void main(String[] args) {
	new GridBagLayoutDemo1().show();
    }
    
    public GridBagLayoutDemo1() {
    	
    	// konstruktor pedka kvli nastaven nzvu okna
    	super("GridBagLayoutDemo1");
    	
    	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	
	// rozmstn komponent do mky, ale nepravideln
	// jedna komponeta zabr jednu i vce bunk
	// umsovn komponenty se d omezenmi, tzv. constraints

	p.setLayout(gbl);
	
        c.fill = GridBagConstraints.BOTH;

        c.weightx = 1.0;
        addJButton(new JButton("Prvn"), 0, 0);
        addJButton(new JButton("Druh"), 1, 0);
        addJButton(new JButton("Tet"), 2, 0);
        
        c.weightx = 0.0;
        c.gridwidth = 2;
        addJButton(new JButton("tvrt"), 0, 1);
    
        c.gridwidth = 1;
        c.weighty = 1.0;
        c.gridheight = 2;
        addJButton(new JButton("Pt"), 2, 1);
        
        c.weighty = 0.0;
        c.gridheight = 1;
        addJButton(new JButton("est"), 0, 2);
        addJButton(new JButton("Sedm"), 1, 2);
	
	// te teprve pidme panel do hlavnho okna
	setContentPane(p);

        // a upravme velikost, aby se tam vechno velo
	pack();
    }
    
    void addJButton(JButton b, int x, int y) {
        c.gridx = x;
        c.gridy = y;
    	gbl.setConstraints(b, c);
    	p.add(b);
    }
    
}	
