package tomp.ucebnice.components;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

/**
 * Prvn zpsob definovn a vytven hlavnho okna aplikace:
 * okno je potomkem JFrame (vdy) a vytvo se v metod main
 * t stejn tdy. 
 * Tato metoda je spoutem celho pg.
 */
public class ImageDemo1 extends JFrame {
	
    public static void main(String[] args) {
	new ImageDemo1().show();
    }
    
    public ImageDemo1() {
    	
    	// konstruktor pedka kvli nastaven nzvu okna
    	super("ImageDemo1");
    	
    	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	
	// toto bude vnitek hlavnho okna
	JPanel p = new JPanel();
	    
	p.setLayout(new BorderLayout());
	
	// prvn vnitn panel
	JPanel p1 = new JPanel();
	p1.add(new JLabel("Prvn panel"));
	
	// druh vnitn panel
	JPanel p2 = new JPanel();
	
	// v nm panel na kreslen
	JPanel c = new MujPanel();
	p2.add(c);

	// panely do hlavnho panelu
	p.add(p1, BorderLayout.NORTH);
	p.add(p2, BorderLayout.SOUTH);
	    
	// te teprve pidme panel do hlavnho okna
	setContentPane(p);

        // a upravme velikost, aby se tam vechno velo
	pack();
    }
}	
class MujPanel extends JPanel {
	
	// obrzek ze souboru
	Image mujObrazek = getToolkit().getImage("salamander.png");
	
	// pekreslen panelu dlme sami
	public void paintComponent(Graphics g) {
		
		System.err.print("\npainting image "+mujObrazek);
		
		// na pltno pouze vykresl obrzek
		// na pozice 10, 10
		g.drawImage(mujObrazek, 10, 10, 
		
			// "pozorovatel" natn obrzku
			new ImageObserver() {
				public boolean imageUpdate(Image im, int info,
	                        	int x, int y, int w, int h) {
    					double celkVyska = (double) im.getHeight(this);
    					int proc = (int) ((y / celkVyska) * 100.0);
    					//pp.setProcenta(proc);
    					boolean hotovo = ((info  &  (ERROR | ALLBITS)) != 0);
    					System.err.print("hotovo "+proc+"% ");
    					if (hotovo)
      						repaint();
    					return !hotovo;
    				}});
    	}
}
