package tomp.ucebnice.konstruktory;

/** E ma jen privatni konstruktor, 
 *  mimo tridu nelze vytvorit instanci
 *  - zajisti tzv. singleton THE_ONLY_E
 */
class E {
    public static final E THE_ONLY_E = new E();
    private E() {
	System.out.println("konstruktor E ");
    }
}

/** EChybne ma jen privatni konstruktor, 
 *  ale nikde neexistuje instance,
 *  - je to prelozitelne, ale k nicemu
 */
class EChybne {
    private EChybne() {
	System.out.println("konstruktor EChybne ");
    }
}

/** FChybne by potrebovala zavolat konstruktor predka, 
 *  to ale nemuze, takze je to neprelozitelne
 */
 
/* 
class FChybne extends EChybne {
    public FChybne() {
	System.out.println("konstruktor FChybne ");
    }
}
*/

public class KonstrPrivate {
    public static void main(String[] args) {

        System.out.print("\nVznika D s parametrem = 5: ");
        D d = new D(5);
        // DChybne dch = new DChybne(5); // chyba!

        System.out.print("\nVznika E? ne!");
        // E e = new E(); // chyba!, konstruktor nelze zavolat

        System.out.print("\nale jedna instance E existuje");
        System.out.print(E.THE_ONLY_E);
    }
}