package tomp.ucebnice.ladeni.loggingapi;

import java.util.logging.Logger;

public class Person {
    
  static Person[] persons =
  {
  	new Person("Pavel Novak"),
  	new Person("Jiri Berkovec"),
  	new Person("Josef Makovsky")
  };

  static Message[] messages =
  {
  	new Message(persons[0], persons[1], "Pavel Jirkovi posila tohle"),
  	new Message(persons[1], persons[2], "Jiri Josefovi zase toto"),
  	new Message(persons[2], persons[0], "Josef Pavlovi vraci tohleto")
  };
  
    /** ziskame logger pro celou tridu,
      * obvykle s nazvem = plne jmeno tridy
      */
    private static Logger PERSON = Logger.getLogger(Person.class.getName());

    private String name;
    
    public Person(String n) {
        name = n;
    }

    public void setName(String n) {
        name = n;
    }
    
    public String getName() {
	    /** logger zaznamena informaci o behu (ne chybu) */
        PERSON.info("vraci jmeno osoby");
        return name;
    }
    
    public void info() {
        System.out.println("osoba: "+getName());
    }    
    
    public static void main(String[] args) {
      for (int i = 0; i < messages.length; i++)
      {
		   System.out.println(messages[i]);
      }
    }
}
class Message {
	
    private static Logger MSG = Logger.getLogger(Message.class.getName());
	
	private static int count = 0;
    
    private int id;
    private java.util.Date created;
    private Person from, to;
    private String text;
    
    public Message() {
    	id = ++count;
    	created = new java.util.Date();
   	}
    
    public Message(Person f, Person t, String x) {
    	this();
    	from = f;
    	to = t;
    	text = x;
    }

    public void setId(int a) {
        id = a;
    }
    
    public int getId() {
        return id;
    }
    
    public java.util.Date getCreated() {
        return created;
    }
    
    public void setCreated(java.util.Date c) {
        created = c;
    }
    
    public void setFrom(Person e) {
        from = e;
    }
    
    public Person getFrom() {
        return from;
    }
    
    public void setTo(Person e) {
        to = e;
    }
    
    public Person getTo() {
        return to;
    }
    
    public void setText(String t) {
        text = t;
    }
    
    public String getText() {
        return text;
    }
    
    public String toString() {
        MSG.info("vraci Message jako String");
    	return "Message "+getId()+": "
    	      +"created: "+getCreated()+", "
    	      +"from: "+getFrom()+", "
    	      +"to: "+getTo()+", "
    		  +"text: "+getText();
    }

}    