package tomp.ucebnice.narodni;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.IOException;
import java.util.Locale;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
public class DatumCas {
    private PrintWriter pw;
    public DatumCas(PrintWriter pw) {
        this.pw = pw;
    }
    public void formatujDatum(Locale l) {
        Date date = new Date();
        String[] formatovaneDatum = {
            "Jazyk = "+l.getDisplayLanguage(),
            "Zem = "+l.getDisplayCountry(),
            "(datum standard, DEFAULT) => "
                + DateFormat.getDateInstance(DateFormat.DEFAULT, l)
                    .format(date),
            "(datum strun, SHORT) => "
                + DateFormat.getDateInstance(DateFormat.SHORT, l)
                    .format(date),
            "(datum stedn, MEDIUM) => "
                + DateFormat.getDateInstance(DateFormat.MEDIUM, l)
                    .format(date),
            "(datum dlouh, LONG) => "
                + DateFormat.getDateInstance(DateFormat.LONG, l)
                    .format(date),
            "(datum pln, FULL) => "
                + DateFormat.getDateInstance(DateFormat.FULL, l)
                    .format(date),
            "(datum vlastn formt) => "
                + new SimpleDateFormat("d. M. yyyy, w. 'tden v roce', D. 'den v roce'", l)
                    .format(date),
            "(as standard, DEFAULT) => "
                + DateFormat.getTimeInstance(DateFormat.DEFAULT, l)
                    .format(date),
            "(as strun, SHORT) => "
                + DateFormat.getTimeInstance(DateFormat.SHORT, l)
                    .format(date),
            "(as stedn, MEDIUM) => "
                + DateFormat.getTimeInstance(DateFormat.MEDIUM, l)
                    .format(date),
            "(as dlouh, LONG) => "
                + DateFormat.getTimeInstance(DateFormat.LONG, l)
                    .format(date),
            "(as pln, FULL) => "
                + DateFormat.getTimeInstance(DateFormat.FULL, l)
                    .format(date),
            "-----"
        };
        for (int i = 0; i < formatovaneDatum.length; i++)
            pw.println(formatovaneDatum[i]);
    }
    public static void main(String args[])
    throws IOException {
        DatumCas d = new DatumCas(new PrintWriter(
            new OutputStreamWriter(System.out, "Cp852"), true));
        d.formatujDatum(new Locale("cs", "CZ"));
        d.formatujDatum(new Locale("sk", "SK"));
        d.formatujDatum(new Locale("en", "US"));
    }
}