package tomp.ucebnice.rozhrani;

interface Choduschopny {
	void start();
	void stop();
}

interface Akcelerujici extends Choduschopny {
	void zrychli();
	void zpomal();
}

class Hodiny implements Choduschopny {
	public void start() {
		System.out.println("Hodiny: start");
	}	
	public void stop() {
		System.out.println("Hodiny: stop");
	}
}

class Vozidlo implements Akcelerujici {
	private String znacka;
	public Vozidlo(String z) {
		znacka = z;
	}
	public String getZnacka() {
		return znacka;
	}
	public void start() {
		System.out.println(toString()+": start");
	}	
	public void stop() {
		System.out.println(toString()+": stop");
	}
	public void zrychli() {
		System.out.println(toString()+": zrychluje");
	}	
	public void zpomal() {
		System.out.println(toString()+": zpomaluje");
	}
	public String toString() {
		return "Vozidlo "+getZnacka();
	}
}

class OsobniAuto extends Vozidlo {
	private int pocetMist;
	public OsobniAuto(String z, int p) {
		super(z);
		pocetMist = p;
	}
	public int getPocetMist() {
		return pocetMist;
	}
	public String toString() {
		return "Osobni auto "+getZnacka();
	}
}

public class Demo {
	
    public static void main(String[] args) {
	Choduschopny h = new Hodiny();
	h.start();
	
	Akcelerujici v = new Vozidlo("ALA 12-34");
	v.start();
	v.zrychli();
	
	Akcelerujici a = new OsobniAuto("CLA 32-98", 5);
	a.start();
	a.zrychli();
	a.zpomal();
	a.stop();
	
	v.stop();
	
	h.stop();
    }
}
