package tomp.ucebnice.swing;

import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import javax.swing.*;

public class SwingGame2 {
    public static void main(String[] args) {

        // Nastav vzhled ("look-and-feel")
        try {
            UIManager.setLookAndFeel(
                UIManager.getCrossPlatformLookAndFeelClassName());
        } catch (Exception e) { }

        // Vytvo aplikaci na hadani cisla
        // nezavislou na GUI
        HadaniCisla hadani = new HadaniCisla(1, 100, 20);

        // Vytvo GUI k aplikaci "hadani"
        HadaniCislaGUI2 app = new HadaniCislaGUI2(hadani);
        
        // Zobraz jej
        app.setVisible(true);
    }
}	


class HadaniCislaGUI2 extends JFrame {
	
    HadaniCisla hadani;
    
    public HadaniCislaGUI2(HadaniCisla h) {
    	
        hadani = h;

        // Nastav titulek okna
        setTitle("Hdn sla od "+hadani.getLow()+" do "+hadani.getHigh());

        // Zsk vnitn panel okna
        JPanel p = new JPanel();

        // Nastav zpsob rozmstn komponent v panelu
        p.setLayout(new FlowLayout());
        p.setPreferredSize(new Dimension(250, 200));

        // Vytvo polko "vzdavam"
        final JCheckBox vzda = new JCheckBox("Vzdvm to!");
        vzda.setSelected(false);
        vzda.setEnabled(true);

        // Pid rychlou npovdu k polku
        vzda.setToolTipText("Zakrtnte, chcete-li hru vzdt.");
        p.add(vzda);

        // Vytvo popisek vstupniho pole
        JLabel popisekVstupuCisla = new JLabel(
            "Hadej cislo od "+hadani.getLow()+" do "+hadani.getHigh());

        // Vstupn textov pole k zadn sla
        final JTextField vstupCisla = new JTextField(20);

        popisekVstupuCisla.setLabelFor(vstupCisla);

        p.add(popisekVstupuCisla);
        p.add(vstupCisla);

        // Vytvo tlatko ke sputn hledn
        JButton tlacitko = new JButton("Zkus to!");
        tlacitko.setToolTipText("Odelete V tip");
            
        // Nastav posluchae akce "stisk tlatka"
        tlacitko.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            	
            	// Vzdal to?
    	       	if (vzda.isSelected()) {
    	       		konec("Vzdal jsi to!!!");
    
    	       	} else {
    	       	
    	                // Tlatko stisknuto: tip sla!
    	                int tip = Integer.parseInt(vstupCisla.getText());
    	                try {
    		                int vysledek = hadani.guess(tip);
    		                if (vysledek == 0)
    		                	uhodl(tip);
    		                else if (vysledek < 0) 
    		                	hlaska("Pli velk, zkus men");
    		                else	
    		                	hlaska("Pli mal, zkus vt");
    		                	
    		            } catch(NumberGuessExceededException nge) {
    		        	
    		        	    konec("Pli mnoho pokus");
    		            }
    		    }
            }
        });
        p.add(tlacitko);

        // Pi zaven okna ukon aplikaci
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        getContentPane().add(p);
        pack();
    }

    void hlaska(String h) {
        JOptionPane.showMessageDialog(
        	this,
	        h, h,
        	JOptionPane.INFORMATION_MESSAGE);
    }
    
    void uhodl(int i) {
    	hlaska("Hdanm slem skuten bylo "+i+", gratulujeme!");
    }

    void konec(String h) {
    	hlaska(h);
    	System.exit(0);
    }
}
