package tomp.ucebnice.testovani;

public class SearcherTest extends junit.framework.TestCase {
    
    Searcher s1;
    
	public SearcherTest(String name) {
		super(name);
	}

    protected void setUp() {
        s1 = new Searcher();
    }
    
    protected void tearDown() {
    }
    
    public void testNonexistent() {
        try {
            s1.setData(null);     
            double min = s1.minimum();
            fail("Should not search in nonexistent array");       
        } catch(IllegalStateException ise) { }
    }
    
    public void testEmpty() {
        try {
            s1.setData(new double[] {});     
            double min = s1.minimum();
            fail("Should not search in empty array");       
        } catch(IllegalStateException ise) { }
    }
    
    public void testMin() {
        s1.setData(new double[] {5, 4.2, -8.1, 1000.2, 1e2});            
        assertEquals("Failed searching minimum in the middle", 
                     -8.1, s1.minimum(), 1e-10);

        s1.setData(new double[] {-1000.2, 1e2, 200});            
        assertEquals("Failed searching minimum at the beginning", 
                     -1000.2, s1.minimum(), 1e-10);

        s1.setData(new double[] {1e2, 200, -1000.2});            
        assertEquals("Failed searching minimum at the end", 
                     -1000.2, s1.minimum(), 1e-10);
    }
}