package tomp.ucebnice.tridy;

class SamostatnaLokalniVBaliku {
    void metoda() {
	System.out.print("metoda SamostatnaLokalniVBaliku ");
    }
}

class Materska {
	private int soukromy = 12345;
	private static int soukromyStaticky = 54321;
	
    	public class VnitrniNestaticka {
    		public void spehujMatku() {
    			System.out.println("Matka ma "+soukromy);
    		}
	};
    	public static class VnitrniStaticka {
    		public void spehujMatku() {
    			// toto uz znovu ne, trida je staticka!
    			// System.out.println("Matka ma "+soukromy);

    			// ale toto ano, staticke vidi!
    			System.out.println("Matka ma staticky "+soukromyStaticky);
    		}
	};
	
	public void testuj() {
		VnitrniNestaticka vn = new VnitrniNestaticka();
		vn.spehujMatku();

		VnitrniStaticka vs = new VnitrniStaticka();
		vs.spehujMatku();
		
		SamostatnaLokalniVBaliku s = new SamostatnaLokalniVBaliku() {
			void metoda() {
				System.out.println("zmenena metoda SamostatnaLokalniVBaliku ");
			}
		};
		s.metoda(); // zmenena !
		
		class LokalniVMetode {
			void metoda() {
				System.out.println("metoda LokalniVMetode ");
			}
		};
		LokalniVMetode lm = new LokalniVMetode();
		lm.metoda(); // OK
	}
}
	
public class Umisteni {

    public static void main(String[] args) {

        System.out.print("\nObjekt tridy SamostatnaLokalniVBaliku: ");
        SamostatnaLokalniVBaliku a = new SamostatnaLokalniVBaliku();
        a.metoda(); // OK, jsme v temze baliku

        System.out.print("\nObjekt tridy Materska: ");
        Materska m = new Materska();
        m.testuj(); // OK, VnitrniNestaticka vidi "soukromy"
                    // OK, VnitrniStaticka vidi aspon "soukromyStaticky"
                    
        m.new VnitrniNestaticka().spehujMatku();      // taky OK
        new Materska.VnitrniStaticka().spehujMatku(); // rovnez OK

    }
}